"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Aneuploidy(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "assembly",
        "chromosome",
        "complete",
        "numberOfCopies",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "coordinates": reports_7_0_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "assembly": reports_7_0_0.Assembly,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "org.gel.models.report.avro.Assembly": reports_7_0_0.Assembly,
            "org.gel.models.report.avro.Coordinates": reports_7_0_0.Coordinates,
            "org.gel.models.report.avro.Aneuploidy": reports_7_0_0.Aneuploidy,
        }

    __slots__ = [
        "assembly",
        "chromosome",
        "complete",
        "numberOfCopies",
        "coordinates",
        "iscn",
    ]

    def __init__(
        self,
        assembly,
        chromosome,
        complete,
        numberOfCopies,
        coordinates=None,
        iscn=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_7_0_0.Aneuploidy model.

        :param assembly:
            The assembly
        :type assembly: Assembly
        :param chromosome:
            Chromosome involved in the aneuploidy
        :type chromosome: str
        :param complete:
            Wheter the aneuploidy is for the whole chromosme or just a fragment
        :type complete: boolean
        :param numberOfCopies:
            Number of copies
        :type numberOfCopies: int
        :param coordinates:
            Coordinates can be specified to indicate the part of the chromosome
            affected
        :type coordinates: None | Coordinates
        :param iscn:
            International System for Human Cytogenetic Nomenclature (.e.g:
            "+14p+", "+t(13q21 q)")
        :type iscn: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "7.0.0"
